/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 * 
 *  Copyright (C) 2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  $Id: test_extsvc1.c 837 2012-12-26 15:09:59Z ertl-hiro $
 */

/* 
 *		ĥӥ˴ؤƥ(1)
 *
 * ڥƥȤŪ
 *
 *  ĥӥ뵡ǽŪ˥ƥȤ롥
 *
 * ڥƥȼ»ܾա
 *
 *  ΥƥȤϡĥӥθƤӽФ˥åΰ褬­
 *  E_NOMEM֤륱ȡͥȥ٥뤬255ĶE_SYS֤륱
 *  ƥȤƤ롥ΥƥȤκݤξ򡤰ʲ2ĤΥåʿ
 *  ͤϥåȤˤۤʤˤǽϤƤ롥
 *
 *  cal_svc returns E_NOMEM when svclevel = 23
 *  cal_svc returns E_SYS when svclevel = 255
 *
 *  ΥƥȤ»ܤˤϡΥåŬڤ
 *  ɬפ롥ŬڤʥåϥåȰ¸Ȥʤ뤿ᡤ
 *  åȤˤäƤϡåʲΤ褦Ĵɬפ롥
 *
 *  嵭E_NOMEM𤵤٤ȤE_SYS𤵤ƥ顼ߤ
 *  ˤϡTASK1Υƥॹå礭롥Τᡤ
 *  OVERFLOW_STACK_SIZEǥեȡSTACK_SIZEˤ⾮ͤ
 *  ɬפ롥
 *
 *  դE_SYS𤵤٤ȤE_NOMEM𤵤ƥ顼ߤ
 *  ˤϡTASK2Υƥॹå롥Τᡤ
 *  NON_OVERFLOW_STACK_SIZEǥեȡSTACK_SIZE * 20ˤ礭
 *  ͤɬפ롥դˡRAM̤­ˤϡͤ
 *  ꤷưǧɬפ롥
 *
 * ڥƥȤǥСͥ
 *		NGKI1243ϡNGKI0189
 *		NGKI3160ϡNGKI3162ϡNGKI3165ϡNGKI3166ϡNGKI3167
 *		NGKI3192ϡNGKI3193ϡNGKI3194
 *		NGKI3195ϡNGKI3197ϡNGKI3198
 *
 * ڹͻ
 *
 * ڥƥȹܡ
 *
 *	(A) ref_texǤγĥӥΥͥȥ٥λȡNGKI1243
 *		(A-1) оݥĥӥƤӽФƤʤ
 *		(A-2) оݥĥӥƤӽФƤꡤͥ
 *			  1λ
 *		(A-3) оݥĥӥƤӽФƤꡤͥ
 *			  2λ
 *		 оݥ¾ǥƥȤ
 *	(B) ø⡼ɤĥӥƤӽФNGKI3160
 *		(B-1) ƥॿĥӥƤ
 *		(B-2) 󥿥ƥȤĥӥƤ
 *		(B-3) ĥӥ뤫ĥӥƤ
 *	(C) ĥӥ뤬μΤȤʤNGKI3162
 *		(C-1) 桼ƤӽФĥӥ뤫顤
 *			  ɥᥤΤߤǤ륪֥Ȥ˥Ǥ
 *	(D) cdmidˤϡĥӥƤӽФñ̤°ɥᥤ
 *		IDϤNGKI3165
 *		(D-1) ƥॿƤӽФˤTDOM_KERNEL
 *		(D-2) 󥿥ƥȤƤӽФˤTDOM_KERNEL
 *		(D-3) ĥӥ뤫ƤӽФˤTDOM_KERNEL
 *		(D-4) 桼ƤӽФˤϡ줬°ݸɥᥤ
 *	(E) par1par5ˤϡĥӥФѥ᡼Ϥ
 *		NGKI3166
 *	(F) cal_svcΥ顼
 *		(F-1) fncd0NGKI3192
 *		(F-2) fncdTMAX_FNCD礭NGKI3193
 *		(F-3) fncdФĥӥ뤬̤NGKI3194
 *		(F-4) åλĤΰ褬­NGKI3197
 *		(F-5) ͥȥ٥뤬¤ĶNGKI3198
 *	(G) ĥӥμ¹Գľξ֡NGKI0189
 *		(G-1) CPUå֤ǸƤӽФ
 *		(G-2) CPUå֤ǸƤӽФ
 *		(G-3) ͥ٥ޥTMAX_INTPRIξ֤ǸƤӽФ
 *		(G-4) ͥ٥ޥ֤ǸƤӽФ
 *		(G-5) ǥѥåػ߾֤ǸƤӽФ
 *		(G-6) ǥѥåľ֤ǸƤӽФ
 *	(H) cal_svc
 *		(H-1) ĥӥ֤ͤNGKI3195
 *	(I) ĥӥΥ꥿󳫻ľξ֡NGKI0189
 *		(I-1) CPUå֤ǥ꥿󤷤
 *		(I-2) CPUå֤ǥ꥿󤷤
 *		(I-3) ͥ٥ޥǤʤ֤ǥ꥿󤷤
 *		(I-4) ͥ٥ޥ֤ǥ꥿󤷤
 *		(I-5) ǥѥåػ߾֤ǥ꥿󤷤
 *		(I-6) ǥѥåľ֤ǥ꥿󤷤
 *	(J) TMAX_FNCDĥӥεǽֹκͤ
 *		NGKI3167
 *
 * ڻѥ꥽
 *
 *	TASK1: 桼ĥӥƤӽФ
 *	TASK2: ƥॿĥӥƤӽФ
 *	TASK3: оݥФƾֻȤ뤿Υ
 *	ALM1: ĥӥƤӽФ
 *	EXTSVC1: ĥӥ
 *	EXTSVC2: ¿ŤǸƤӽФĥӥ
 *	EXTSVC3: 顼ˤʤޤ¿Ť˸ƤӽФӥ
 *
 * ڥƥȥ󥹡
 *
 *	== TASK1ͥ١10==
 *	1:	act_tsk(TASK2) -> E_OACV
 *		act_tsk(TASK3)
 *	== TASK3-1ͥ١91ܡ==
 *	2:	ref_tsk(TASK1, &rtsk)
 *		assert(rtsk.svclevel == 0)							... (A-1)
 *		ext_tsk()
 *	== TASK1³==
 *	3:	cal_svc(0, 0, 0, 0, 0, 0) -> E_RSFN					... (F-1)
 *		cal_svc(TFN_EXTSVC3+1, 0, 0, 0, 0, 0) -> E_RSFN		... (F-2)(J)
 *		cal_svc(TFN_EXTSVC0, 0, 0, 0, 0, 0) -> E_RSFN		... (F-3)
 *		cal_svc(TFN_EXTSVC1, PAR1_1, PAR1_2, PAR1_3, PAR1_4, PAR1_5) \
 *															... (G-2)(G-4)(G-6)
 *	== EXTSVC1-11ܡ==
 *	4:	state(false, false, TIPM_ENAALL, false, false, true)
 *		assert(par1 == PAR1_1 && par2 == PAR1_2 && par3 == PAR1_3 \
 *				&& par4 == PAR1_4 && par5 == PAR1_5)		... (E)
 *		assert(cdmid == DOM1)								... (D-4)
 *		act_tsk(TASK3)
 *	== TASK3-22ܡ==
 *	5:	ref_tsk(TASK1, &rtsk)
 *		assert(rtsk.svclevel == 1)							... (A-2)
 *		ext_tsk()
 *	== EXTSVC1-1³==
 *	6:	cal_svc(TFN_EXTSVC2, PAR2_1, PAR2_2, PAR2_3, PAR2_4, PAR2_5) ... (B-3)
 *	== EXTSVC2-11ܡ==
 *	7:	state(false, false, TIPM_ENAALL, false, false, true)
 *		assert(par1 == PAR2_1 && par2 == PAR2_2 && par3 == PAR2_3 \
 *				&& par4 == PAR2_4 && par5 == PAR2_5)		... (E)
 *		assert(cdmid == TDOM_KERNEL)						... (D-3)
 *		act_tsk(TASK3)
 *	== TASK3-33ܡ==
 *	8:	ref_tsk(TASK1, &rtsk)
 *		assert(rtsk.svclevel == 2)							... (A-2)
 *		ext_tsk()
 *	== EXTSVC2-1³==
 *	9:	dis_dsp()
 *		chg_ipm(TMAX_INTPRI)
 *		loc_cpu()
 *		RETURN(E_OK)										... (I-1)(I-3)(I-5)
 *	== EXTSVC1-1³==
 *	10:	state(false, true, TMAX_INTPRI, true, true, true)
 *		cal_svc(TFN_EXTSVC2, 0, 0, 0, 0, 0) -> E_PAR		... (G-1)(G-3)(G-5)
 *	== EXTSVC2-22ܡ==
 *	11:	state(false, true, TMAX_INTPRI, true, true, true)
 *		unl_cpu()
 *		chg_ipm(TIPM_ENAALL)
 *		RETURN(E_PAR)										... (H-1)(I-2)(I-4)
 *	== EXTSVC1-1³==
 *	12:	state(false, false, TIPM_ENAALL, true, true, true)
 *		ena_dsp()											... (I-6)
 *		act_tsk(TASK2)										... (C-1)
 *		RETURN(E_OK)
 *	== TASK1³==
 *	13:	state(false, false, TIPM_ENAALL, false, false, true)
 *		cal_svc(TFN_EXTSVC3, 0, 0, 0, 0, 0) -> E_NOMEM		... (F-4)
 *	..  EXTSVC3 ¹Ԥ뤬νϼ񤭤
 *	== TASK1³==
 *	14:	ext_tsk()
 *	== TASK2ͥ١10==
 *	15:	act_tsk(TASK3)
 *	== TASK3-44ܡ==
 *	16:	ref_tsk(TASK2, &rtsk)
 *		assert(rtsk.svclevel == 0)							... (A-1)
 *		ext_tsk()
 *	== TASK2³==
 *	17:	cal_svc(0, 0, 0, 0, 0, 0) -> E_RSFN					... (F-1)
 *		cal_svc(TFN_EXTSVC3+1, 0, 0, 0, 0, 0) -> E_RSFN		... (F-2)
 *		cal_svc(TFN_EXTSVC0, 0, 0, 0, 0, 0) -> E_RSFN		... (F-3)
 *		cal_svc(TFN_EXTSVC1, 0, 0, 0, 0, 0)					... (B-1)
 *	== EXTSVC1-22ܡ==
 *	18:	state(false, false, TIPM_ENAALL, false, false, true)
 *		assert(cdmid == TDOM_KERNEL)						... (D-1)
 *		act_tsk(TASK3)
 *	== TASK3-55ܡ==
 *	19:	ref_tsk(TASK2, &rtsk)
 *		assert(rtsk.svclevel == 1)							... (A-2)
 *		ext_tsk()
 *	== EXTSVC1-2³==
 *	20:	RETURN(E_OK)
 *	== TASK2³==
 *	21:	cal_svc(TFN_EXTSVC3, 0, 0, 0, 0, 0) -> E_SYS		... (F-4)
 *	..  EXTSVC3 ¹Ԥ뤬νϼ񤭤
 *	== TASK2³==
 *	22:	sta_alm(ALM1, 0U)
 *		dly_tsk(1U)
 *	== ALM1 ==
 *	23:	cal_svc(0, 0, 0, 0, 0, 0) -> E_RSFN					... (F-1)
 *		cal_svc(TFN_EXTSVC3+1, 0, 0, 0, 0, 0) -> E_RSFN		... (F-2)
 *		cal_svc(TFN_EXTSVC0, 0, 0, 0, 0, 0) -> E_RSFN		... (F-3)
 *		cal_svc(TFN_EXTSVC1, 0, 0, 0, 0, 0)					... (B-2)
 *	== EXTSVC1-33ܡ==
 *	24:	state_i(true, false, false, true, true)
 *		assert(cdmid == TDOM_KERNEL)						... (D-2)
 *		RETURN(E_OK)
 *	== ALM1³==
 *	25:	state_i(true, false, false, true, true)
 *		RETURN
 *	== TASK2³==
 *	26:	END
 */

#include <kernel.h>
#include <test_lib.h>
#include <t_syslog.h>
#include <t_stdlib.h>
#include "kernel_cfg.h"
#include "test_extsvc1.h"

#define PAR1_1		((intptr_t) 1)
#define PAR1_2		((intptr_t) 2)
#define PAR1_3		((intptr_t) 3)
#define PAR1_4		((intptr_t) 4)
#define PAR1_5		((intptr_t) 5)

#define PAR2_1		((intptr_t) -5)
#define PAR2_2		((intptr_t) -4)
#define PAR2_3		((intptr_t) -3)
#define PAR2_4		((intptr_t) -2)
#define PAR2_5		((intptr_t) -1)

/*
 *  extsvc3_routineʤ
 *
 *  γĥӥǤϡͥȥ٥κƥȤ뤿ᡤ
 *  椫ĥӥƤǤ⡤Ƥ٤Ȥϸ¤ʤ
 */

ER_UINT
extsvc3_routine(intptr_t par1, intptr_t par2, intptr_t par3,
								intptr_t par4, intptr_t par5, ID cdmid)
{
	ER		ercd, ercd1;
	T_RTSK	rtsk;

	ercd = cal_svc(TFN_EXTSVC3, 0, 0, 0, 0, 0);
	if (ercd < 0) {
		ercd1 = ref_tsk(TSK_SELF, &rtsk);
		check_ercd(ercd1, E_OK);

		if (SERCD(ercd) == -1) {
			/*
			 *  ǤͥȤοĥӥ1٤å
			 *  Ϥ롥
			 *
			 *  cal_svcE_SYS֤ǤϡĥӥƽФ
			 *  ޤsyslogؿϻȤʤᡤsyslog_wri_logؿ
			 *  Ф롥
			 */
			{
				SYSLOG	logbuf;
				char	*msg = "cal_svc returns %s when svclevel = %d";

				logbuf.logtype = LOG_TYPE_COMMENT;
				logbuf.loginfo[0] = (intptr_t) msg;
				logbuf.loginfo[1] = (intptr_t) itron_strerror(ercd);
				logbuf.loginfo[2] = (intptr_t) rtsk.svclevel;
				(void) _syslog_syslog_wri_log(LOG_NOTICE, &logbuf);
			}
			ercd = ERCD(MERCD(ercd), -2);
		}
		if (rtsk.svclevel == 1) {
			return(ERCD(MERCD(ercd), -1));
		}
	}
	return(ercd);
}

/*
 *  鲼
 */

void
alarm1_handler(intptr_t exinf)
{
	ER		ercd;

	check_point(23);

	ercd = cal_svc(0, 0, 0, 0, 0, 0);
	check_ercd(ercd, E_RSFN);

	ercd = cal_svc(TFN_EXTSVC3+1, 0, 0, 0, 0, 0);
	check_ercd(ercd, E_RSFN);

	ercd = cal_svc(TFN_EXTSVC0, 0, 0, 0, 0, 0);
	check_ercd(ercd, E_RSFN);

	ercd = cal_svc(TFN_EXTSVC1, 0, 0, 0, 0, 0);
	check_ercd(ercd, E_OK);

	check_point(25);
	check_state_i(true, false, false, true, true);

	return;

	check_point(0);
}

static uint_t	extsvc1_count = 0;

ER_UINT
extsvc1_routine(intptr_t par1, intptr_t par2, intptr_t par3,
								intptr_t par4, intptr_t par5, ID cdmid)
{
	ER		ercd;

	switch (++extsvc1_count) {
	case 1:
		check_point(4);
		check_state(false, false, TIPM_ENAALL, false, false, true);
		check_assert(par1 == PAR1_1 && par2 == PAR1_2 && par3 == PAR1_3 && par4 == PAR1_4 && par5 == PAR1_5);
		check_assert(cdmid == DOM1);

		ercd = act_tsk(TASK3);
		check_ercd(ercd, E_OK);

		check_point(6);

		ercd = cal_svc(TFN_EXTSVC2, PAR2_1, PAR2_2, PAR2_3, PAR2_4, PAR2_5);
		check_ercd(ercd, E_OK);

		check_point(10);
		check_state(false, true, TMAX_INTPRI, true, true, true);

		ercd = cal_svc(TFN_EXTSVC2, 0, 0, 0, 0, 0);
		check_ercd(ercd, E_PAR);

		check_point(12);
		check_state(false, false, TIPM_ENAALL, true, true, true);

		ercd = ena_dsp();
		check_ercd(ercd, E_OK);

		ercd = act_tsk(TASK2);
		check_ercd(ercd, E_OK);

		return(E_OK);

		check_point(0);

	case 2:
		check_point(18);
		check_state(false, false, TIPM_ENAALL, false, false, true);
		check_assert(cdmid == TDOM_KERNEL);

		ercd = act_tsk(TASK3);
		check_ercd(ercd, E_OK);

		check_point(20);

		return(E_OK);

		check_point(0);

	case 3:
		check_point(24);
		check_state_i(true, false, false, true, true);
		check_assert(cdmid == TDOM_KERNEL);

		return(E_OK);

		check_point(0);
	}
	check_point(0);
	return(E_SYS);
}

static uint_t	extsvc2_count = 0;

ER_UINT
extsvc2_routine(intptr_t par1, intptr_t par2, intptr_t par3,
								intptr_t par4, intptr_t par5, ID cdmid)
{
	ER		ercd;

	switch (++extsvc2_count) {
	case 1:
		check_point(7);
		check_state(false, false, TIPM_ENAALL, false, false, true);
		check_assert(par1 == PAR2_1 && par2 == PAR2_2 && par3 == PAR2_3 && par4 == PAR2_4 && par5 == PAR2_5);
		check_assert(cdmid == TDOM_KERNEL);

		ercd = act_tsk(TASK3);
		check_ercd(ercd, E_OK);

		check_point(9);

		ercd = dis_dsp();
		check_ercd(ercd, E_OK);

		ercd = chg_ipm(TMAX_INTPRI);
		check_ercd(ercd, E_OK);

		ercd = loc_cpu();
		check_ercd(ercd, E_OK);

		return(E_OK);

		check_point(0);

	case 2:
		check_point(11);
		check_state(false, true, TMAX_INTPRI, true, true, true);

		ercd = unl_cpu();
		check_ercd(ercd, E_OK);

		ercd = chg_ipm(TIPM_ENAALL);
		check_ercd(ercd, E_OK);

		return(E_PAR);

		check_point(0);
	}
	check_point(0);
	return(E_SYS);
}

void
task1(intptr_t exinf)
{
	ER		ercd;

	check_point(1);

	ercd = act_tsk(TASK2);
	check_ercd(ercd, E_OACV);

	ercd = act_tsk(TASK3);
	check_ercd(ercd, E_OK);

	check_point(3);

	ercd = cal_svc(0, 0, 0, 0, 0, 0);
	check_ercd(ercd, E_RSFN);

	ercd = cal_svc(TFN_EXTSVC3+1, 0, 0, 0, 0, 0);
	check_ercd(ercd, E_RSFN);

	ercd = cal_svc(TFN_EXTSVC0, 0, 0, 0, 0, 0);
	check_ercd(ercd, E_RSFN);

	ercd = cal_svc(TFN_EXTSVC1, PAR1_1, PAR1_2, PAR1_3, PAR1_4, PAR1_5);
	check_ercd(ercd, E_OK);

	check_point(13);
	check_state(false, false, TIPM_ENAALL, false, false, true);

	ercd = cal_svc(TFN_EXTSVC3, 0, 0, 0, 0, 0);
	check_ercd(ercd, E_NOMEM);

	check_point(14);

	ercd = ext_tsk();
	check_ercd(ercd, E_OK);

	check_point(0);
}

void
task2(intptr_t exinf)
{
	ER		ercd;

	check_point(15);

	ercd = act_tsk(TASK3);
	check_ercd(ercd, E_OK);

	check_point(17);

	ercd = cal_svc(0, 0, 0, 0, 0, 0);
	check_ercd(ercd, E_RSFN);

	ercd = cal_svc(TFN_EXTSVC3+1, 0, 0, 0, 0, 0);
	check_ercd(ercd, E_RSFN);

	ercd = cal_svc(TFN_EXTSVC0, 0, 0, 0, 0, 0);
	check_ercd(ercd, E_RSFN);

	ercd = cal_svc(TFN_EXTSVC1, 0, 0, 0, 0, 0);
	check_ercd(ercd, E_OK);

	check_point(21);

	ercd = cal_svc(TFN_EXTSVC3, 0, 0, 0, 0, 0);
	check_ercd(ercd, E_SYS);

	check_point(22);

	ercd = sta_alm(ALM1, 0U);
	check_ercd(ercd, E_OK);

	ercd = dly_tsk(1U);
	check_ercd(ercd, E_OK);

	check_finish(26);

	check_point(0);
}

static uint_t	task3_count = 0;

void
task3(intptr_t exinf)
{
	ER		ercd;
	T_RTSK	rtsk;

	switch (++task3_count) {
	case 1:
		check_point(2);

		ercd = ref_tsk(TASK1, &rtsk);
		check_ercd(ercd, E_OK);
		check_assert(rtsk.svclevel == 0);

		ercd = ext_tsk();
		check_ercd(ercd, E_OK);

		check_point(0);

	case 2:
		check_point(5);

		ercd = ref_tsk(TASK1, &rtsk);
		check_ercd(ercd, E_OK);
		check_assert(rtsk.svclevel == 1);

		ercd = ext_tsk();
		check_ercd(ercd, E_OK);

		check_point(0);

	case 3:
		check_point(8);

		ercd = ref_tsk(TASK1, &rtsk);
		check_ercd(ercd, E_OK);
		check_assert(rtsk.svclevel == 2);

		ercd = ext_tsk();
		check_ercd(ercd, E_OK);

		check_point(0);

	case 4:
		check_point(16);

		ercd = ref_tsk(TASK2, &rtsk);
		check_ercd(ercd, E_OK);
		check_assert(rtsk.svclevel == 0);

		ercd = ext_tsk();
		check_ercd(ercd, E_OK);

		check_point(0);

	case 5:
		check_point(19);

		ercd = ref_tsk(TASK2, &rtsk);
		check_ercd(ercd, E_OK);
		check_assert(rtsk.svclevel == 1);

		ercd = ext_tsk();
		check_ercd(ercd, E_OK);

		check_point(0);
	}
	check_point(0);
}
